<?php
// validation_functions.php
// this file contains validations
// coded by gautam arora
class validationErrors
{
var $errors = array();
function get_Unformatted_errors()
{
//return error in array
	return $this->errors;
}
function get_Formatted_errors()
{
//return error in string formatted
 	$myErrors ="";
	$errCount = count($this->errors);
	$myErrors = $myErrors. "<ul>";
	for($i =0;$i < $errCount;$i++)
	{
	$myErrors = $myErrors. "<li>". $this->errors[$i] ."</li>";
	}
	$myErrors = $myErrors. "</ul>";
	return $myErrors;
}
function get_errors()
{
//return error in string formatted
 	$myErrors ="";
	$errCount = count($this->errors);
	for($i =0;$i < $errCount;$i++)
	{
	$myErrors = $myErrors.  $this->errors[$i] ."</br>";
	}
	return $myErrors;
}
function anyError()
{
//check if any error occured
	if(count($this->errors) > 0)
	{
	return true;
	} 
	else
	{
	return false;
	}
}

function addErr($errMsg)
{
//allows error to be added from outside the class
	$this->errors[] = $errMsg;
}

//isEmpty
function isEmpty($value,$errMsg)
{
	$value = trim($value);
	if(empty($value))
	{
	$this->errors[] = $errMsg;
	}
}	
//function for numeric check
function chkNumeric($fieldname,$value,$greaterthan='',$lessthan='')
{
	if(!empty($value))
	{
		if (!is_numeric($value)) 
		{
		$this->errors[] = $fieldname ." "."should be numeric";	
		}
		elseif(is_numeric($greaterthan))
		{
			if($value < $greaterthan)
			{
			$this->errors[] = $fieldname ." "."should be more than ".$greaterthan;
			}
		}
		elseif(is_numeric($lessthan))
		{
			if($value > $lessthan)
			{
			$this->errors[] = $fieldname ." "."should be less than ".$lessthan;
			}
		}
	}	
	
}
//allow only alphabets
function chkAlphabets($fieldname,$value,$min_length='',$max_length='')
{
	$wordlength = strlen($value);
	//length of the word is also passed so that it checks all the characters. 
	//if we do not pass the length then pregmatch returns true even if it finds only one matching char
	$pattern = "([a-z]{".$wordlength."})";
	
	if(!preg_match($pattern,$value,$matches))
	{
	$this->errors[] = "Only alphabets allowed in ".$fieldname;
	}
}

//allow  alphabets,numerics,spaces
function chkAlphanumeric($fieldname,$value,$min_length='',$max_length='')
{
	$wordlength = strlen($value);
	//length of the word is also passed so that it checks all the characters. 
	//if we do not pass the length then pregmatch returns true even if it finds only one matching char
	//this function will allow A-z 1-100 and space
	$pattern = "([a-z 0-9]{".$wordlength."})";
	
	if(!preg_match($pattern,$value,$matches))
	{
	$this->errors[] = "Only alpha numeric values are allowed in ".$fieldname;
	}
}

//check length
function chkLength($fieldname,$value,$min_length='',$max_length='')
{
	if(is_numeric($min_length))
	{
		if(strlen($value) < $min_length)
		{
		$this->errors[] = "Minimum allowed length for ".$fieldname ." is ".$min_length;
		}
	}
	if(is_numeric($max_length))
	{
		if(strlen($value) > $max_length)
		{
		$this->errors[] = "Max allowed length for ".$fieldname ." is ".$min_length;
		}
	}
}
//compare two values
function chkComparison($value1,$value2,$caseCheck,$errMsg)
{
	//case sensitive check
	if(strtoupper($caseCheck) == "YES")
	{
		if(strcmp($value1,$value2) <> 0)
		{
		$this->errors[] = $errMsg;
		}
	}
	else
	{
	//case insensitive check
		if(strcasecmp($value1,$value2) <> 0)
		{
		$this->errors[] = $errMsg;
		}
	}	
}
//check mail formatting
function chkEmailformat($value)
{
	if (!ereg('^[a-zA-Z0-9_\.\-]+@[a-zA-Z0-9\-]+\.[a-zA-Z0-9\-\.]+$',$value)) 
	{
	$this->errors[] = "Please enter valid email address";
	}
}
//check url formatting
function chkUrlformat($value)
{
if (!ereg('^http://www.[a-zA-Z0-9_\.\-]+\.[a-zA-Z\-\./_]+$',$value) || !ereg('^http://[a-zA-Z0-9_\.\-]+\.[a-zA-Z\-\./_]+$',$value))
	{
	$this->errors[] = "Please enter valid site URL";
	}
}
//check file extension
//file_name = name of file which needs extension check
//$extensions_allowed = extensions that is allowed to be passed as string ex ".jpeg,.gif,.pdf" etc
function chkfileExtension($file_name,$extensions_allowed,$errMsg='')
{
	if(!empty($file_name))
	{
		$current_file_extension=getfileExtension($file_name);
		if(stristr($extensions_allowed,$current_file_extension)== false)
		{
			if(empty($errMsg))
			{
			$this->errors[] = $current_file_extension ." files are not allowed";
			}
			else
			{
			$this->errors[] = $errMsg;
			}
		}
	}
}
//check if file is already present
function chkfileExists($folderPath,$fileName)
{
	if(file_exists($folderPath.'/'.$fileName) && strlen(trim($fileName))>3)
	{
	$this->errors[] = "File already exists";
	}
}
//check if is it a folder 
function chkfolderExists()
{

}

//check is folder writeable
function chkisfolderWriteable()
{

}

//this function checks if there is any duplicate value
//use this for username,email etc
//value = value that needs to be checked
//conobj = connection object
//table = table name that needs to be checked
//column = column name that needs to be checked for where clause
//recid= id of current record.Required when in edit mode
//recid_column_name = coulmn name of record. required in case of edit mode
//isEdit = is the record being edited ?
function chkUnique($value,$conObj,$table,$column,$recid=0,$recid_column_name='',$isEdit,$errMsg)
{
	$sql = 'select count(*) from '.$table. ' where '.$column."='".$value."'";
	if($isEdit == true)
	{
	//if in edit mode
	$sql = $sql . ' and '.$recid_column_name." !='".$recid."'";	
	}

   	 $this->last_query = $sql;      
      $r = mysql_query($sql);
      if (!$r) {
         $this->last_error = mysql_error();
		 //$this->print_last_error();
         return false;
      }
	  
	 $row = mysql_fetch_array($r);
	 if ($row[0] > 0)
	 {
	 $this->errors[] = $errMsg;
	 }
	 
}
//end of class
}
?>