<?php
// image_functions.php
// coded by gautam arora

//resize the pic
function picResize($width, $height, $target) 
{ 
if ($width > $height) 
{ 
	$percentage = ($target / $width); 
} 
else 
{ 
	$percentage = ($target / $height); 
} 
$width = round($width * $percentage); 
$height = round($height * $percentage); 
return array($width,$height); 
} 

//function to create thumbnail of image
function createThumbnail($srcFolder,$srcFile,$dest,$thmbWidth,$thmbHeight,$base,$new_name_of_file='')
{
//$src = source 
//$dest = destination
//$thmbWidth = thumbnail width
//$thmbHeight = thumbnail height
//$base = height OR weigth that will be used for proportional resizing
//$new_name_of_file = new name of thumbnail that will be created, just pass the filename with no extension
	
		 
	//allowed extensions
	$extension_array[] = "jpg";
	$extension_array[] = "jpeg";
	$extension_array[] = "gif";
	
	//check if source exists
	if((!file_exists($srcFolder.'/'.$srcFile)) || (!is_file($srcFolder.'/'.$srcFile) == true))
	{
		return "Source doesn't exists";
	}
	//get file extension
	$ext = getfileExtension($srcFile);
	//check if souce is valid for thumbnail creation
	if(!in_array($ext,$extension_array))
	{
		return "Only image files are allowed";
	}
	//check if destination exists
	if(!file_exists($dest))
	{
		return "Destination doesn't exists";
	}
	//check if destination is writable
	if(!is_writable($dest))
	{
		return "Destination is not writable";
	}
	//check if width is numeric
	if(!is_numeric($thmbWidth))
	{
		return "thumb width should be numeric";
	}
	//check if height is numeric
	if(!is_numeric($thmbHeight))
	{
		return "thumb height should be numeric";
	}
	//get the image with and height of main image
	$mysock = getimagesize($srcFolder.'/'.$srcFile);
	//resize image
	if($mysock[0] > $thmbWidth || $mysock[1] > $thmbHeight)
	{
		if($base == "w")
		{
		$resizeBy = $thmbWidth;
		}
		else
		{
		$resizeBy = $thmbHeight;
		}
		$new_size=picResize($mysock[0],$mysock[1], $resizeBy);
		$newWidth = $new_size[0];
		$newHeight = $new_size[1];
		
	}
	else
	{
		$newWidth=$mysock[0];
		$newHeight=$mysock[1];
	}
	
	//create thumbnail
	if(empty($new_name_of_file))
	{
	$thName = $dest."/".$srcFile;
	}
	else
	{
	$thName = $dest."/".$new_name_of_file.'.'.$ext;
	}
	
	if($ext == 'gif')
	{
	$mainimage = imagecreatefromgif($srcFolder.'/'.$srcFile);
	}
	else
	{
	$mainimage = imagecreatefromjpeg($srcFolder.'/'.$srcFile);
	}
	
	$mythumbnail = imagecreatetruecolor($newWidth,$newHeight);
	$mainwidth = imagesx($mainimage);
	$mainheight = imagesy($mainimage);
	imagecopyresampled($mythumbnail,$mainimage,0,0,0,0,$newWidth,$newHeight,$mainwidth,$mainheight);
	if($ext == 'gif')
	{
	ImageGIF($mythumbnail,$thName,75);
	}
	else
	{
	ImageJPEG($mythumbnail,$thName,75);
	}
	
	imagedestroy($mythumbnail);
	imagedestroy($mainimage);	
	
	// return 1 on success
	return 1;

}
// thumb nail function ends here

//display image
function displayImage($folder,$file,$alt='',$class='',$url='',$extra='')
{
$str="";
	if((!empty($folder)) && (!empty($file)))
	{
		if(file_exists($folder."/".$file) && strlen($file) > 2) 
		{
			if(!empty($url))
			{
			$str = $str .'<a href="'.$url.'"';
			}
			if(!empty($extra))
			{
			$str = $str . " $extra ";
			}
			if(!empty($url))
			{
			$str = $str .'>';
			}
			$str = $str .'<img src="'.$folder."/".$file.'"';
			if(!empty($alt))
			{
			$str = $str .' alt="'.$alt.'"';
			}
			if(!empty($class))
			{
			$str = $str .' class="'.$class.'"';
			}
			$str = $str .'>';
			if(!empty($url))
			{
			$str = $str .'</a>';
			}
			return $str; 
					
		}
	}	
}
?>
